LeetCode 1269. Number of Ways to Stay in the Same Place After Some Steps

Posted Dylan_Java_NYC

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了LeetCode 1269. Number of Ways to Stay in the Same Place After Some Steps相关的知识,希望对你有一定的参考价值。

原题链接在这里:https://leetcode.com/problems/number-of-ways-to-stay-in-the-same-place-after-some-steps/

题目:

You have a pointer at index 0 in an array of size arrLen. At each step, you can move 1 position to the left, 1 position to the right in the array or stay in the same place  (The pointer should not be placed outside the array at any time).

Given two integers steps and arrLen, return the number of ways such that your pointer still at index 0 after exactly steps steps.

Since the answer may be too large, return it modulo 10^9 + 7.

Example 1:

Input: steps = 3, arrLen = 2
Output: 4
Explanation: There are 4 differents ways to stay at index 0 after 3 steps.
Right, Left, Stay
Stay, Right, Left
Right, Stay, Left
Stay, Stay, Stay

Example 2:

Input: steps = 2, arrLen = 4
Output: 2
Explanation: There are 2 differents ways to stay at index 0 after 2 steps
Right, Left
Stay, Stay

Example 3:

Input: steps = 4, arrLen = 2
Output: 8

Constraints:

  • 1 <= steps <= 500
  • 1 <= arrLen <= 10^6

题解:

For each step, it could go left, right or stay.

Let dp[i] denotes number of ways to get to i.

next[i] = dp[i - 1] + dp[i] + dp[i + 1].

We only care about len = math.min(steps / 2 + 1, arrLen) since if it is beyond steps / 2 + 1, then it could not come back to 0.

To handle i == 0 and i == dp.length - 1 with i- 1 and i + 1, initialize dp as len + 2. Then first and last would always be 0.

Time Complexity: O(steps * len). len = Math.min(steps / 2 + 1, arrLen).

Sapce: O(len).

AC Java:

 1 class Solution {
 2     public int numWays(int steps, int arrLen) {
 3         int mod = 1000000007;
 4         int len = Math.min(steps / 2 + 1,  arrLen);
 5         
 6         long [] dp = new long[len + 2];
 7         dp[1] = 1; 
 8         while(steps-- > 0){
 9             long [] next = new long[len + 2];
10             for(int i = 1; i < dp.length - 1; i++){
11                 next[i] = (dp[i - 1] + dp[i] + dp[i + 1]) % mod;
12             }
13             
14             dp = next;
15         }
16         
17         return (int)dp[1];
18     }
19 }

类似Knight Dialer.

以上是关于LeetCode 1269. Number of Ways to Stay in the Same Place After Some Steps的主要内容,如果未能解决你的问题,请参考以下文章

LeetCode Number of Islands II

LeetCode Number of Boomerangs

LeetCode(191):Number of 1 Bits

[LeetCode]Number of 1 Bits

Leetcode 200. Number of Islands

LeetCode 191. Number of 1 Bits